import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class WBCanvas extends JPanel{
  //Canvas ׸ ׸  ׷ ü
  private Graphics g = null;
  //  ϰ ִ  ü
  private Pen p = null;
  //콺 ǥ  ϱ  
  private int xp = 0;
  private int yp = 0;
  private int xr = 0;
  private int yr = 0;

  public WBCanvas(){}
  
  public WBCanvas(Pen p) {
    this.p = p;
    
    //MouseEvent ʸ  Ŭ 
    addMouseListener(new MouseAdapter() {
      //콺 ư   콺  ġ 
      public void mousePressed(MouseEvent e) {
        xp = e.getX();
        yp = e.getY();
      }
      
      //콺 ư ȴ   콺  ġ 
      public void mouseReleased(MouseEvent e) {
        xr = e.getX();
        yr = e.getY();
        
        // 콺  ġ Ʋ draw()޼ ȣ
        if(xp != xr && yp != yr) {
          draw();
        }
      }
    });
  }
  
  public void draw() {
    //׷ ü ۷ ´.
    g = getGraphics();
  
    // Ÿ θ switch ˻Ͽ ش 
    //Graphics ü ̿ canvas 
    switch(p.getType()) {
      //簢 
      case 0:
        g.drawRect(getStartX(), getStartY(), getW(), getH());
        break;
      //ﰢ 
      case 1:
        g.drawPolygon(getArrayX(), getArrayY(), 3);
        break;
      //𼭸 ձ 簢 
      case 2:
        g.drawRoundRect(getStartX(), getStartY(), getW(), getH(),20,20);
        break;
      // 
      case 3:
        g.drawOval(getStartX(), getStartY(), getW(), getH());
        break;
      //ä ä 
      case 4:
        g.fillArc(getStartX()-getW(), getStartY(), getW()*2, getH(),-45,90);
        break;
      // 
      case 5:
        g.drawLine(xp, yp, xr, yr);
        break;
      //ÿ 
      case 6:
        g.clearRect(getStartX(), getStartY(), getW(), getH());
        break;
      default:
        break;
    }
  }
  
  //콺    xǥ  ȯѴ.
  private int getStartX() {
    if(xp > xr)
      return xr;
          
    return xp;
  }
  
  //콺    yǥ  ȯѴ.
  private int getStartY() {
    if(yp > yr)
      return yr;
          
    return yp;
  }
  
  // yǥ  ū yǥ   ȯ
  private int getH() {
    int h = 0;
    
    if(yp > yr)
      h = yp - yr;
    else
      h = yr - yp;
      
    return h;
  }
  
  // xǥ  ū xǥ   ȯ
  private int getW() {
    int w = 0;
    
    if(xp > xr)
      w = xp - xr;
    else
      w = xr - xp;
      
    return w;
  }
  
  //ﰢ ׸ xǥ 迭 ȯ
  private int[] getArrayX() {
    int xa[] = new int[3];
    if(xp > xr) {
      xa[0] = xr;
      xa[1] = xr + (xp-xr) / 2;
      xa[2] = xp;
    } else {
      xa[0] = xp;
      xa[1] = xp + (xr-xp) / 2;
      xa[2] = xr;
    }
    return xa;
  }
  
  //ﰢ ׸ yǥ 迭 ȯ
  private int[] getArrayY() {
    int ya[] = new int[3];
    if(yp > yr) {
      ya[0] = yp;
      ya[1] = yr;
      ya[2] = yp;
    } else {
      ya[0] = yr;
      ya[1] = yp;
      ya[2] = yr;
    }
    return ya;
  }
}